<template>
  <q-page padding>
    <template v-if="dataSet !== undefined">
      <MenuAcciones
        :uuid="uuid"
        :cerrado="dataSet?.eventos_estado_id === 4"
        v-if="!dataSet.borrado && dataSet.soy_propietario"
      />
    </template>

    <q-banner
      v-if="dataSet?.responsable === user.persona.apellidoynombre"
      inline-actions
      rounded
      class="text-white bg-blue q-mt-sm"
    >
      Hola {{ user.persona.nombre }}, sos el responsable de esta experiencia,
      podes completar, tu equipo
    </q-banner>

    <q-card class="q-mt-sm">
      <template v-if="dataSet !== undefined">
        <q-tabs
          v-model="tab"
          dense
          class="text-grey"
          active-color="primary"
          indicator-color="primary"
          align="justify"
          narrow-indicator
        >
          <q-tab name="informacion" label="Información" />
          <q-tab name="descripcion" label="Descripcion / Pauta" />
          <q-tab
            name="equipo"
            label="Equipo de Adultos"
            v-if="!dataSet.borrado && dataSet.soy_propietario"
          />
        </q-tabs>
        <q-separator />
        <q-tab-panels v-model="tab" animated>
          <q-tab-panel name="informacion">
            <InformacionPartial :evento="dataSet" />
            <BotonEstadoPartial :evento="dataSet" />
          </q-tab-panel>
          <q-tab-panel name="descripcion">
            <div v-html="dataSet.pauta" />
          </q-tab-panel>
          <q-tab-panel name="equipo">
            <ListadoEquipoPartial />
          </q-tab-panel>
        </q-tab-panels>
      </template>
    </q-card>
    <div class="q-mt-sm" v-if="dataSet">
      <ListadoInscriptosPartial :key="dataSet.uuid" :evento="dataSet" />
    </div>

    <q-inner-loading
      :showing="dataSet === undefined"
      label="obteniendo informacion del evento ..."
      label-class="text-teal"
      label-style="font-size: 1.1em"
    />
  </q-page>
</template>

<script lang="ts">
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import moment from 'moment';
import { QTableProps } from 'quasar';
import { EventoDetalleInterface } from 'src/interfaces/EventosInterface';
import { useUserStore } from 'src/stores/user';
import { defineComponent, onMounted, ref, Ref } from 'vue';
import { useRoute } from 'vue-router';
import MenuAcciones from './_AccionesPartial.vue';
import BotonEstadoPartial from './_BotoneraEstadoPartial.vue';
import InformacionPartial from './_InformacionPartial.vue';
import ListadoEquipoPartial from './_ListadoEquipoPartial.vue';
import ListadoInscriptosPartial from './_ListadoInscriptosPartial.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'funcion', label: 'Función', field: 'funcion', align: 'left' },
  { name: 'estado', label: 'Estado', field: 'estado', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: {
    ListadoInscriptosPartial,
    InformacionPartial,
    ListadoEquipoPartial,
    BotonEstadoPartial,
    MenuAcciones,
  },

  name: 'EventosPage',
  setup() {
    const store = useUserStore();
    const dataSet = ref<EventoDetalleInterface>();
    const loading = ref(true);
    const progress: Ref<boolean[]> = ref([]);
    const route = useRoute();
    const uuid = <string>route.params.uuid;
    onMounted(() => {
      getEventos();
    });

    function getEventos() {
      api
        .get<EventoDetalleInterface>('/api/eventos/eventos/' + uuid)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data;
        });
    }

    return {
      user: store.details,
      uuid,
      tab: ref('informacion'),
      loading,
      dataSet,
      columnas,
      moment,
      progress,
    };
  },
});
</script>
